Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/EqualsExpressions.cs	(revision 15334)
@@ -83,6 +83,5 @@
     StackTypes.Boolean,
     "BOOLEAN.=",
-    "Pushes TRUE onto the BOOLEAN stack if the top two BOOLEAN items are equal, or FALSE otherwise.",
-    StackTypes.Boolean)]
+    "Pushes TRUE onto the BOOLEAN stack if the top two BOOLEAN items are equal, or FALSE otherwise.")]
   public class BooleanEqualsExpression : EqualsExpression<bool> {
     public BooleanEqualsExpression() { }
@@ -125,5 +124,5 @@
     "Pushes TRUE onto the BOOLEAN stack if the top two EXEC items are equal, or FALSE otherwise.",
     StackTypes.Boolean,
-    execIn: 0)]
+    requiredBlockCount: 0)]
   public class ExecEqualsExpression : EqualsExpression<Expression> {
     public ExecEqualsExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExecExpressions.cs	(revision 15334)
@@ -20,5 +20,5 @@
     "If the top item of the BOOLEAN stack is TRUE then this removes the second item on the EXEC stack, leaving the first item to be executed. If it is false then it removes the first item, leaving the second to be executed.",
     StackTypes.Boolean,
-    execIn: 2)]
+    requiredBlockCount: 2)]
   public class ExecIfExpression : StatelessExpression {
     public ExecIfExpression() { }
@@ -45,5 +45,5 @@
     "EXEC.Y",
     "Inserts beneath the top item of the EXEC stack a new item of the form \"( EXEC.Y <TopItem> )\"",
-    execIn: 1)]
+    requiredBlockCount: 1)]
   [StorableClass]
   public class ExecYExpression : StatelessExpression {
@@ -54,5 +54,5 @@
     public override bool IsNoop(IInternalPushInterpreter interpreter) {
       return interpreter.ExecStack.Count == 0 ||
-             interpreter.Configuration.MaxPointsInProgram < 2 ||
+             interpreter.Configuration.MaxProgramLength < 2 ||
              (interpreter.ExecStack.Top.IsProgram && ((PushProgram)interpreter.ExecStack.Top).Depth == interpreter.Configuration.MaxDepth);
     }
@@ -80,5 +80,5 @@
     "EXEC.K",
     "Removes the second item on the EXEC stack.",
-    execIn: 2)]
+    requiredBlockCount: 2)]
   [StorableClass]
   public class ExecKExpression : StatelessExpression {
@@ -106,5 +106,5 @@
     "EXEC.S",
     "Pops 3 items from the EXEC stack called A, B, and C. Then pushes a list containing B and C back onto the EXEC stack, followed by another instance of C, followed by another instance of A.",
-    execIn: 3)]
+    requiredBlockCount: 3)]
   [StorableClass]
   public class ExecSExpression : StatelessExpression {
@@ -167,5 +167,5 @@
     "EXEC.WHILE",
     "Executes top EXEC item recursively as long top BOOLEAN is TRUE.",
-    StackTypes.Boolean, execIn: 1)]
+    StackTypes.Boolean, requiredBlockCount: 1)]
   [StorableClass]
   public class ExecWhileExpression : StatelessExpression {
@@ -196,5 +196,5 @@
     "EXEC.DO*WHILE",
     "Executes top EXEC item recursively until max. amount of eval. expressions is reached or top EXEC item removes the the recursive call.",
-    execIn: 1)]
+    requiredBlockCount: 1)]
   [StorableClass]
   public class ExecDoWhileExpression : StatelessExpression {
@@ -220,5 +220,5 @@
     "Top EXEC item is only executed, if top BOOLEAN is TRUE.",
     StackTypes.Boolean,
-    execIn: 1)]
+    requiredBlockCount: 1)]
   [StorableClass]
   public class ExecWhenExpression : StatelessExpression {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/Expression.cs	(revision 15334)
@@ -1,5 +1,4 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System;
-  using System.Collections.Generic;
 
   using HeuristicLab.Common;
@@ -20,10 +19,5 @@
     public bool IsProgram { get { return GetType() == typeof(PushProgram); } }
 
-    public static readonly IReadOnlyCollection<Expression> EmptyContainer = new Expression[0];
-
-    public abstract string StringRepresentation
-    {
-      get;
-    }
+    public abstract string StringRepresentation { get; }
 
     public abstract bool IsNoop(IInternalPushInterpreter interpreter);
@@ -43,5 +37,5 @@
 
     public object Clone() {
-      return Clone(new Cloner());
+      return this;
     }
 
@@ -50,6 +44,4 @@
     }
 
-    void IPooledObject.Init() { }
-
     void IPooledObject.Reset() { }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ExpressionTable.cs	(revision 15334)
@@ -6,4 +6,7 @@
   using Attributes;
   using Data.Pool;
+
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Extensions;
+
   using Stack;
 
@@ -124,27 +127,5 @@
     }
 
-    private static bool IsSubclassOf(Type type, Type baseType) {
-      if (type == null || baseType == null || type == baseType)
-        return false;
-
-      if (baseType.IsGenericType == false) {
-        if (type.IsGenericType == false)
-          return type.IsSubclassOf(baseType);
-      } else {
-        baseType = baseType.GetGenericTypeDefinition();
-      }
-
-      type = type.BaseType;
-      var objectType = typeof(object);
-      while (type != objectType && type != null) {
-        var curentType = type.IsGenericType ? type.GetGenericTypeDefinition() : type;
-        if (curentType == baseType)
-          return true;
-
-        type = type.BaseType;
-      }
-
-      return false;
-    }
+
 
     private static IEnumerable<Type> GetExpressionTypes(Type baseType) {
@@ -152,5 +133,5 @@
              from assemblyType in domainAssembly.GetTypes()
              where !assemblyType.IsAbstract &&
-                   IsSubclassOf(assemblyType, baseType) &&
+                   assemblyType.IsSubclass(baseType) &&
                    assemblyType.GetConstructor(Type.EmptyTypes) != null
              select assemblyType;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/FloatExpressions.cs	(revision 15334)
@@ -341,4 +341,5 @@
   /// </summary>
   [PushExpression(StackTypes.Float, "FLOAT.COS", "Pushes the cosine of the top item.")]
+  [StorableClass]
   public class FloatCosineExpression : StatelessExpression {
     public FloatCosineExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PopExpressions.cs	(revision 15334)
@@ -84,5 +84,5 @@
 
   [StorableClass]
-  [PushExpression(StackTypes.Exec, "EXEC.POP", "Pops the top EXEC item.", execIn: 1)]
+  [PushExpression(StackTypes.Exec, "EXEC.POP", "Pops the top EXEC item.", requiredBlockCount: 1)]
   public class ExecPopExpression : PopExpression<Expression> {
     public ExecPopExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PrintExpressions.cs	(revision 15334)
@@ -26,4 +26,20 @@
 
   [StorableClass]
+  [PushExpression(StackTypes.Print, "PRINT.ENSURE_NEWLINE", "Pushes an empty string onto the PRINT STACK if current line isn't empty already.")]
+  public class PrintEnsureNewLineExpression : StatelessExpression {
+    public PrintEnsureNewLineExpression() { }
+    [StorableConstructor]
+    protected PrintEnsureNewLineExpression(bool deserializing) : base(deserializing) { }
+
+    public override bool IsNoop(IInternalPushInterpreter interpreter) {
+      return interpreter.PrintStack.IsCurrentLineEmpty;
+    }
+
+    public override void Eval(IInternalPushInterpreter interpreter) {
+      interpreter.PrintStack.NewLine();
+    }
+  }
+
+  [StorableClass]
   public abstract class PrintExpression<T> : StatelessExpression {
     protected PrintExpression() { }
@@ -104,5 +120,5 @@
     "Pushes the top BOOLEAN onto the EXEC stack.",
     StackTypes.Exec,
-    execIn: 1)]
+    requiredBlockCount: 1)]
   public class ExecPrintExpression : PrintExpression<Expression> {
     public ExecPrintExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/PushProgram.cs	(revision 15334)
@@ -5,4 +5,6 @@
 namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System.Diagnostics;
+  using System.Diagnostics.CodeAnalysis;
+
   using Constants;
   using Data.Pool;
@@ -38,5 +40,5 @@
 
     [StorableConstructor]
-    public PushProgram(bool deserializing) : this(EmptyExpressions) { }
+    private PushProgram(bool deserializing) : this(EmptyExpressions) { }
 
     public PushProgram(IReadOnlyList<Expression> expressions) {
@@ -67,6 +69,4 @@
     }
 
-    void IPooledObject.Init() { }
-
     void IPooledObject.Reset() {
       expressions = null;
@@ -159,4 +159,5 @@
     [NonSerialized]
     private int? hashCode;
+    [SuppressMessage("ReSharper", "NonReadonlyMemberInGetHashCode")]
     public override int GetHashCode() {
       if (hashCode == null) hashCode = expressions.HashCode();
@@ -256,19 +257,20 @@
       get
       {
-        if (branches == null) {
-          branches = 1;
-
-          for (var i = 0; i < Count; i++) {
-            var expression = expressions[i];
-
-            if (!expression.IsProgram)
-              continue;
-
-            var program = (PushProgram)expression;
-            branches += program.Branches;
-          }
-        }
-
+        if (branches == null) CountBranches();
         return branches.Value;
+      }
+    }
+
+    private void CountBranches() {
+      branches = 1;
+
+      for (var i = 0; i < Count; i++) {
+        var expression = expressions[i];
+
+        if (!expression.IsProgram)
+          continue;
+
+        var program = (PushProgram)expression;
+        branches += program.Branches;
       }
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/RotateExpressions.cs	(revision 15334)
@@ -100,5 +100,5 @@
     "EXEC.ROT",
     "Rotates the top 3 items of the EXEC stack clockwise.",
-    execIn: 3)]
+    requiredBlockCount: 3)]
   [StorableClass]
   public class ExecRotateExpression : RotateExpression<Expression> {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/ShoveExpressions.cs	(revision 15334)
@@ -107,5 +107,5 @@
     "Moves the top EXEC item to a specific stack index, whereby the index is taken from the INTEGER stack.",
     StackTypes.Integer,
-    execIn: 1)]
+    requiredBlockCount: 1)]
   [StorableClass]
   public class ExecShoveExpression : ShoveExpression<Expression> {
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StatefulExpression.cs	(revision 15334)
@@ -69,6 +69,4 @@
     }
 
-    void IPooledObject.Init() { }
-
     public void Reset() {
       State = default(T);
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/StringExpressions.cs	(revision 15334)
@@ -122,5 +122,5 @@
     public override bool IsNoop(IInternalPushInterpreter interpreter) {
       return interpreter.StringStack.Count < 2 ||
-             interpreter.StringStack.Top.Length + interpreter.StringStack[1].Length >= interpreter.Configuration.MaxStringLength;
+             interpreter.StringStack.Top.Length + interpreter.StringStack[1].Length > interpreter.Configuration.MaxStringLength;
     }
 
@@ -148,5 +148,5 @@
       return interpreter.StringStack.IsEmpty ||
              interpreter.CharStack.IsEmpty ||
-             interpreter.StringStack.Top.Length + 1 >= interpreter.Configuration.MaxStringLength;
+             interpreter.StringStack.Top.Length + 1 > interpreter.Configuration.MaxStringLength;
     }
 
@@ -618,12 +618,24 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var result = GetResultString(interpreter);
+
+      // Should be checked in isNoop but would require to calculate result twice which is an expensive operation
+      if (result.Length > interpreter.Configuration.MaxStringLength)
+        return;
+
+      interpreter.StringStack.Remove(2);
+      interpreter.StringStack.Top = result;
+    }
+
+    private static string GetResultString(IInternalPushInterpreter interpreter) {
       var third = interpreter.StringStack[2];
       var second = interpreter.StringStack[1];
       var first = interpreter.StringStack[0];
-      interpreter.StringStack.Remove(2);
-
-      interpreter.StringStack.Top = third.Length == 0 || second.Length == 0
+
+      var result = third.Length == 0 || second.Length == 0
         ? third
         : third.Replace(second, first);
+
+      return result;
     }
   }
@@ -647,12 +659,23 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
+      var result = GetResultString(interpreter);
+
+      // Should be checked in isNoop but would require to calculate result twice which is an expensive operation
+      if (result.Length > interpreter.Configuration.MaxStringLength)
+        return;
+
+      interpreter.StringStack.Remove(2);
+      interpreter.StringStack.Top = result;
+    }
+
+    private static string GetResultString(IInternalPushInterpreter interpreter) {
       var third = interpreter.StringStack[2];
       var second = interpreter.StringStack[1];
       var first = interpreter.StringStack[0];
-      interpreter.StringStack.Remove(2);
-
-      interpreter.StringStack.Top = third.Length == 0 || second.Length == 0
+
+      var result = third.Length == 0 || second.Length == 0
         ? third
         : ReplaceFirst(third, second, first);
+      return result;
     }
 
@@ -802,5 +825,5 @@
     "STRING.ITERATE",
     "Iterates over the top STRING using the CODE on the EXEC stack.",
-    StackTypes.Exec | StackTypes.Char, execIn: 1)]
+    StackTypes.Exec | StackTypes.Char, requiredBlockCount: 1)]
   public class StringIterateExpression : StatelessExpression {
     public StringIterateExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/SwapExpressions.cs	(revision 15334)
@@ -104,5 +104,5 @@
     "EXEC.SWAP",
     "Swaps the top two items on the stack.",
-    execIn: 2)]
+    requiredBlockCount: 2)]
   public class ExecSwapExpression : SwapExpression<Expression> {
     public ExecSwapExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/VectorIterateExpressions.cs	(revision 15334)
@@ -67,5 +67,5 @@
     "Iterates in reverse order (due to performance reasons) over the top INTEGER[] using the top item of the EXEC stack.",
     StackTypes.Integer | StackTypes.Exec,
-    execIn: 1)]
+    requiredBlockCount: 1)]
   public class IntegerVectorIterateExpression : VectorIterateExpression<long> {
     public IntegerVectorIterateExpression() { }
@@ -87,5 +87,5 @@
     "FLOAT[].ITERATE",
     "Iterates in reverse order (due to performance reasons) over the top FLOAT[] using the top item of the EXEC stack.",
-    StackTypes.Float | StackTypes.Exec, execIn: 1)]
+    StackTypes.Float | StackTypes.Exec, requiredBlockCount: 1)]
   public class FloatVectorIterateExpression : VectorIterateExpression<double> {
     public FloatVectorIterateExpression() { }
@@ -107,5 +107,5 @@
     "BOOLEAN[].ITERATE",
     "Iterates in reverse order (due to performance reasons) over the top BOOLEAN[] using the top item of the EXEC stack.",
-    StackTypes.Boolean | StackTypes.Exec, execIn: 1)]
+    StackTypes.Boolean | StackTypes.Exec, requiredBlockCount: 1)]
   public class BooleanVectorIterateExpression : VectorIterateExpression<bool> {
     public BooleanVectorIterateExpression() { }
@@ -127,5 +127,5 @@
     "STRING[].ITERATE",
     "Iterates in reverse order (due to performance reasons) over the top STRING[] using the top item of the EXEC stack.",
-    StackTypes.String | StackTypes.Exec, execIn: 1)]
+    StackTypes.String | StackTypes.Exec, requiredBlockCount: 1)]
   public class StringVectorIterateExpression : VectorIterateExpression<string> {
     public StringVectorIterateExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankDuplicateExpressions.cs	(revision 15334)
@@ -116,5 +116,5 @@
     "EXEC.YANKDUP",
     "Pushes a copy of an indexed item \"deep\" in the stack onto the top of the stack, without removing the deep item.",
-    StackTypes.Integer, execIn: 0)]
+    StackTypes.Integer, requiredBlockCount: 0)]
   public class ExecYankDuplicateExpression : YankDuplicateExpression<Expression> {
     public ExecYankDuplicateExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/YankExpressions.cs	(revision 15334)
@@ -115,5 +115,5 @@
     "Removes an indexed item from \"deep\" in the stack and pushes it on top of the stack.",
     StackTypes.Integer,
-    execIn: 0)]
+    requiredBlockCount: 0)]
   public class ExecYankExpression : YankExpression<Expression> {
     public ExecYankExpression() { }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/ControlExntensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/ControlExntensions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Extensions/ControlExntensions.cs	(revision 15334)
@@ -17,4 +17,5 @@
 
       if (propertyInfo == null ||
+          // ReSharper disable once AssignNullToNotNullAttribute
           !control.GetType().IsSubclassOf(propertyInfo.ReflectedType) ||
           control.GetType().GetProperty(
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/InduvidualMapper.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/InduvidualMapper.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Individual/InduvidualMapper.cs	(revision 15334)
@@ -47,6 +47,6 @@
         var expressionType = expression.GetType();
 
-        if (config.ParenthesesCloseBiasLevel > 0) {
-          close += random.NextBiased(0, config.MaxParenthesesClose, config.ParenthesesCloseBiasLevel);
+        if (config.CloseBiasLevel > 0) {
+          close += random.NextBiased(0, config.MaxClose, config.CloseBiasLevel);
 
           // check if expression requires additional blocks
@@ -54,5 +54,5 @@
             var attr = ExpressionTable.TypeToAttributeTable[expressionType];
 
-            for (var blockIdx = 0u; blockIdx < attr.ExecIn && currentIndex < vector.Length; blockIdx++) {
+            for (var blockIdx = 0u; blockIdx < attr.RequiredBlockCount && currentIndex < vector.Length; blockIdx++) {
               if (close != 0) {
                 close--;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/Extensions.cs	(revision 15334)
@@ -77,12 +77,22 @@
 
     public static void PrintStacks(this IPushInterpreter interpreter) {
+      var maxStackNameLength = interpreter.Stacks.Max(x => x.Key.ToString().Length);
+      var totalLength = maxStackNameLength + 6;
+
       foreach (var pair in interpreter.Stacks) {
         var stackName = pair.Key.ToString();
         var stack = interpreter.Stacks[pair.Key];
 
-        if (stack.IsEmpty || !stack.IsEnabled) continue;
+        if (stack.IsEmpty || !stack.IsEnabled)
+          continue;
 
-        var stackString = string.Join(" ", interpreter.StringifyStack(pair.Key).Reverse());
-        Console.WriteLine("--------- {0} ---------\n{1}\n", stackName, stackString);
+        var stackString = string.Join(" ", interpreter.StringifyStack(pair.Key));
+
+        //var padLength = (totalLength - stackName.Length) / 2;
+        //var padLengthLeft = stackName.Length + padLength;
+        //var padLengthRight = padLengthLeft + padLength;
+        //Console.WriteLine("{0}\n{1}\n", stackName.PadLeft(padLengthLeft, '-').PadRight(padLengthRight, '-'), stackString);
+
+        Console.WriteLine("{0}: {1}", stackName, stackString);
       }
 
@@ -96,13 +106,16 @@
 
     public static void InitExample(this IPushInterpreter interpreter, Example example) {
-      interpreter.BooleanStack.Push(example.InputBoolean);
-      interpreter.IntegerStack.Push(example.InputInteger);
-      interpreter.FloatStack.Push(example.InputFloat);
-      interpreter.CharStack.Push(example.InputChar);
-      interpreter.StringStack.Push(example.InputString);
-      interpreter.StringVectorStack.Push(example.InputStringVector);
-      interpreter.IntegerVectorStack.Push(example.InputIntegerVector);
-      interpreter.FloatVectorStack.Push(example.InputFloatVector);
+      if (interpreter.Configuration.TopLevelPushInputArguments) {
+        interpreter.BooleanStack.Push(example.InputBoolean);
+        interpreter.IntegerStack.Push(example.InputInteger);
+        interpreter.FloatStack.Push(example.InputFloat);
+        interpreter.CharStack.Push(example.InputChar);
+        interpreter.StringStack.Push(example.InputString);
+        interpreter.StringVectorStack.Push(example.InputStringVector);
+        interpreter.IntegerVectorStack.Push(example.InputIntegerVector);
+        interpreter.FloatVectorStack.Push(example.InputFloatVector);
+      }
 
+      // init in expressions
       interpreter.SetInput(
         integers: example.InputInteger,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreter.cs	(revision 15334)
@@ -31,5 +31,5 @@
 
       // setting the capacity of the Stacks to max points ensures that there will be enough memory at runtime
-      ExecStack = new PushStack<Expression>(Configuration.MaxPointsInProgram);
+      ExecStack = new PushStack<Expression>(Configuration.MaxProgramLength);
       CodeStack = new PushStack<Expression>();
       NameStack = new PushStack<string>();
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs	(revision 15333)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Interpreter/PushInterpreterPool.cs	(revision 15334)
@@ -22,8 +22,10 @@
       ExpressionListPoolProvider = new ManagedPoolProvider<PooledList<Expression>>(poolPartitionSize, () => new PooledList<Expression>(), maxPartitionCount);
 
-      pool = new ObjectPool<PooledPushInterpreter>(() => {
-        var poolContainer = new InterpreterPoolContainer(PushProgramPoolProvider, ExpressionListPoolProvider);
-        return new PooledPushInterpreter(this, PushConfiguration, poolContainer);
-      }, size);
+      pool = new ObjectPool<PooledPushInterpreter>(CreateInterpreter, size);
+    }
+
+    private PooledPushInterpreter CreateInterpreter() {
+      var poolContainer = new InterpreterPoolContainer(PushProgramPoolProvider, ExpressionListPoolProvider);
+      return new PooledPushInterpreter(this, PushConfiguration, poolContainer);
     }
 
@@ -31,6 +33,9 @@
 
     public PooledPushInterpreter Create(IRandom random = null) {
-      var interpreter = pool.Allocate();
-      interpreter.Reset(random);
+      //var interpreter = pool.Allocate();
+      //interpreter.Reset(random);
+
+      var poolContainer = new InterpreterPoolContainer(PushProgramPoolProvider, ExpressionListPoolProvider);
+      var interpreter = new PooledPushInterpreter(this, PushConfiguration, poolContainer, random);
 
       return interpreter;
